# Summary

[Laboratoare PCom 🌐](labs.md)

# 01. Networking warmup
----
- [Lectură laborator](lab1/lecture.md)
- [Despre laboratoarele de PCom](lab1/about.md)
- [Nivelul fizic](lab1/physical.md)
- [Internetul](lab1/internet.md)
- [Networking de mână](lab1/manual_networking.md)
- [Monitorizarea traficului](lab1/monitoring.md)
  - [Wireshark](lab1/wireshark.md)
  - [tcpdump](lab1/tcpdump.md)
- [Noțiuni generale de programare](lab1/basic_c.md)
  - [Compilare](lab1/compilation.md)
  - [Debugging](lab1/debugging.md)
  - [File descriptors](lab1/files.md)
- [Exerciții](lab1/exercises.md)

# Nivelul Datalink
---

# 02. Datalink. Framing
----

- [Lectură laborator](lab2/lecture.md)
- [Framing](lab2/theoretical_intro.md)
  - [Bit Stuffing](lab2/bit_stuffing.md)
  - [Character (byte) stuffing](lab2/practical_bit_stuffing.md)
- [Tipuri de comunicatie](lab2/types.md)
  - [Point-to-Point](lab2/point_to_point.md)
  - [Point-to-Multipoint](lab2/point_to_multipoint.md)
- [Metrici](lab2/metrics.md)
- [Exerciții](lab2/exercises.md)

# 03. Transfer de date peste un link imperfect.
----

- [Lectură laborator](lab3/lecture.md)
- [Detectarea și corectarea erorilor de transmisie](lab3/error_detection.md)
- [Redundanță](lab3/redundancy.md)
- [Sume de control](lab3/checksum.md)
- [Cyclic Redundancy Codes (CRCs)](lab3/crc.md)
- [Endianness](lab3/endianness.md)
- [Exerciții](lab3/exercises.md)

# Nivelul Retea
---

# 04. Protocolul IP. Forwarding
----

- [Lectură laborator](lab4/lecture.md)
- [Routing](lab4/routing.md)
- [Protocoale utilizate](lab4/protocols.md)
  - [Ethernet](lab4/ethernet.md)
  - [IPV4](lab4/ipv4.md)
    - [Adrese IP](lab4/ip_addresses.md)
- [Procesul de forward (dirijiare)](lab4/forwarding.md)
  - [Longest Prefix Match](lab4/lpm.md)
- [Mininet](lab4/setup.md)
  - [Utilizare](lab4/mininet.md)
- [Exerciții](lab4/exercises.md)

# Nivelul Transport
---

# 05. Procolul UDP. Fereastra glisanta.
----
- [Lectură laborator](lab5/lecture.md)
- [Nivelul Transport](lab5/transport.md)
  - [Porturi](lab5/ports.md)
- [Protocolul UDP](lab5/udp.md)
  - [Header UDP](lab5/udp_header.md)
- [Sockets](lab5/sockets.md)
  - [Comunicare client-server UNIX](lab5/client_serv.md)
  - [socket()](lab5/create_socket.md)
  - [bind()](lab5/bind.md)
  - [recvfrom()/ sendto()](lab5/recv.md)
  - [close()/ shutdown()](lab5/close.md)
- [Sockets in alte limbaje](lab5/beyond.md)
- [Stop-And-Wait](lab5/stop_and_wait.md)
- [Fereastra Glisanta](lab5/sliding_window.md)
  - [Dimensiuena Ferestrei](lab5/window_size.md)
- [Exerciții](lab5/exercises.md)

# 06. Retransmisie peste UDP. Go-Back-N ARQ.
----
- [Lectură laborator](lab6/lecture.md)
- [Retransmisie](lab6/reliable_udp.md)
- [Go-Back-N ARQ](lab6/go_back_n.md)
- [Implementare fereastra glisanta](lab6/sliding_window.md)
- [Numar de secventa](lab6/seq_num.md)
- [Exerciții](lab6/exercises.md)

# 07. Protocolul TCP. Multiplexare IO.
----
- [Lectură laborator](lab7/lecture.md)
- [Protocolul TCP](lab7/tcp.md)
  - [Header TCP](lab7/tcp_header.md)
- [API Sockets pentru TCP](lab7/tcp_sockets.md)
  - [connect()](lab7/connect.md)
  - [listen()](lab7/listen.md)
  - [accept()](lab7/accept.md)
  - [send()/recv()](lab7/send.md)
  - [Exemplu client](lab7/client.md)
  - [Exemplu server](lab7/server.md)
- [Multiplexare I/O](lab7/multiplexing.md)
- [Timere](lab7/timerfd.md)
- [Exerciții](lab7/exercises.md)

# 08. TCP Congestion Control
----

- [Lectură laborator](lab8/lecture.md)
- [Colapsul congestiei din 1986](lab8/collapse.md)
- [Controlul Congestiei](lab8/cc.md)
- [Slow Start](lab8/slow_start.md)
- [AIMD](lab8/aimd.md)
- [Etapele TCP](lab8/overview.md)
- [iperf](lab8/iperf.md)
- [Socket Stats](lab8/ss.md)
- [Exerciții](lab8/exercises.md)

# Nivelul Aplicatie
---

# 09. Protocolul HTTP
----
- [Lectură laborator](lab9/lecture.md)
- [Protocolul HTTP](lab9/http.md)
- [Cereri HTTP](lab9/http_req.md)
- [Cookies](lab9/cookies.md)
- [Raspunsuri HTTP](lab9/responses.md)
- [Sesiune si autentificare](lab9/session.md)
- [Exerciții](lab9/exercises.md)


# 10. DNS & E-mail
----
- [Lectură laborator](lab10/lectura.md)
- [Obiective](lab10/obiective.md)
- [Protocolul DNS](lab10/dns/protocolul.md)
  - [Spațiul de nume](lab10/dns/spatiul.md)
  - [Algoritmul de interogare](lab10/dns/algo.md)
  - [Înregistrări de resurse (records)](lab10/dns/records.md)
  - [Servere de nume](lab10/dns/ns.md)
  - [API DNS](lab10/dns/api.md)
  - [Cereri DNS în Linux](lab10/dns/terminal.md)
    - [Utilitarul dig](lab10/dns/dig.md)
- [E-mail](lab10/mail/email.md)
  - [Protocoalele SMTP, POP3 și IMAP](lab10/mail/protocoale.md)
    - [SMTP](lab10/mail/smtp.md)
    - [POP3](lab10/mail/pop3.md)
    - [IMAP](lab10/mail/imap.md)
- [Exerciții](lab10/exercitii.md)
  - [Exerciții DNS](lab10/dns/exercitii.md)
  - [Exerciții E-mail](lab10/mail/exercitii.md)


# Networking avansat
---

# 11. Securitate
----
- [Lectură laborator](lab11/lecture.md)
- [Primitive criptografice](lab11/crypto/primitives.md)
- [Principiul lui Kerckhoffs](lab11/crypto/kerckhoffs.md)
- [Criptare simetrică](lab11/crypto/symmetric.md)
- [Criptare asimetrică](lab11/crypto/asymmetric.md)
- [Hasing](lab11/crypto/hashing.md)
- [Semnături digitale](lab11/crypto/signatures.md)
- [Entități de încredere](lab11/crypto/trust.md)
- [Exerciții](lab11/exercises.md)


# 12. Transport Layer Security (TLS)
----
- [Lectură laborator](lab12/lecture.md)
- [Transport Layer Security](lab12/tls.md)
- [OpenSSL](lab12/openssl.md)
- [TLS Handshake](lab12/tls_handshake.md)
  - [Implementare](lab12/handshake_exercise.md)
- [Certificate](lab12/create_certificate.md)
- [Server HTTPS](lab12/tls_server.md)
