### Redundanță

Redundanța reprezintă repetarea informației.

Adesea adjectivul "redundant" e folosit cu conotații negative, pentru ceva
superfluu.
În domeniul comunicării redundanța are însă un rol important, deoarece permite
_detecția și corecția erorilor_.

#### Sudoku

Vom folosi ca exemplu ilustrativ familiarul joc Sudoku.

<iframe frameborder="0" scrolling="no"
src="resources/sudoku.html" style="border:0px solid #eee;
overflow:hidden; width:400px; height:550px;" width="400"></iframe>

Scopul jocului este completarea unei grile de 9x9 căsuțe cu cifrele de la 1 la
9, astfel încât acestea să apară exact o singură dată pe fiecare din cele nouă
_linii_, _coloane_ și _regiuni_ (de 3x3 căsuțe).

Inițial, un astfel de puzzle conține doar o parte din cifrele necesare, restul
căsuțelor fiind goale; jucătorul trebuie să pornească de la aceste indicii
inițiale și să descopere _soluția unică_.

Faptul că putem șterge multe cifre dintr-un careu complet pentru a obține un
puzzle cu soluție unică, înseamnă că avem de-a face cu un nivel ridicat de
redundanță.
Dacă un emițător ar dicta un careu anume prin telefon, dar unele dintre cife ar
fi inaudibile, am putea totuși să obținem careul inițial.

> Evident, nu putem elimina oricâte cifre și să păstrăm unicitatea soluției.
> [Este nevoie de minim 17 cifre pentru a avea soluție
> unică](https://arxiv.org/abs/1201.0749), dar chiar și așa nu orice mulțime de
64 de cifre poate fi eliminată; [există puzzle-uri cu 77 de cifre fără soluție
unică](https://math.stackexchange.com/a/345255).
> Concluzia este că analiza redundanței unui joc de Sudoku e complicată.
>
> Metodele de detecție și corecție a erorilor studiate de noi (și aplicate în
> practică) prezintă caracteristici mai ușor de înțeles.
