# Dimensiunea ferestrei

Vom presupune un caz simplu în care 2 gazde pot comunica datagrame
UDP peste mai multe link-uri:

```
          L1                L2               L3
Host A <------> Router <--------> Switch <-------> Host B

L1, L2, L3 - 10 MBps, 5ms latenta, 0% pierderi de pachete
```

**Cum calculam dimensiunea ferestrei?** Cum toate link-urile au aceiasi parametrii, vom face calculul o singură dată.
Primul pas este determinarea valorii BDP-ului (Bandwidth Delay Product):

\\( BDP = 10 {MB/s} * 5 {ms} = 10 * 10^6 {B/s} * 5 * 10^{-3} {s} = 50000 {bytes} = 50 {KB} \\)

În cazul în care datagramele pe care le trimitem au cel mult `1500 bytes`, atunci
pentru a folosi link-ul într-un mod optim, dimensiunea ferestrei este următoarea:

\\( {windows\_size} = [{BDP} / {Datagram Size}] = [50000 / 1500] = 30 \\)

> Am presupus ca dimensiunea maxima de `1500 bytes` include și antelele protocoalelor
de nivel inferior precum IP și Ethernet.
