# Exercitii

> **Scheletul laboratorului se regaseste la adresa de
[aici](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/tree/master/lab6).
Funcționalitatea disponibilă este descrisă în README.md. În continuare, vom folosi Mininet pentru a simula o topologie simplă: `sudo python3 topo.py`.**

Antetul protocolului pe care îl dezvoltăm astăzi este descris mai jos. Protocolul îl vom implementa peste UDP.

```
|Seq Number|Length|
```

**1.** Vom dezvolta un protocol simplu de retransmisie. Vom trimite un segment, dacă primim un ACK, trimitem segmentul cu secvența precedentă + 1. Vom folosi o opțiune specială pe socket pentru a seta un timer de o secundă pe el. Astfel, dacă `recv` nu primește date într-un anumit timp, o să expire timer-ul și o să retransmitem toate segmentele din fereastra.

```c
struct timeval timeout;      
timeout.tv_sec = 1;
timeout.tv_usec = 0;

if (setsockopt (sockfd, SOL_SOCKET, SO_RCVTIMEO, &timeout,
	sizeof timeout) < 0
error("setsockopt failed\n");
```

> Vom rula Wireshark pe router pentru a face depanarea.

**2.** Vom extinde implementarea precedentă de protocol pentru a folosi tehnica de fereastra glisantă. Vom implementa Go-Back-N. Vom calcula dimensiunea ferestrei de transmisie în funcție de lungimea de bandă și latență.

<img src="images/Go-Back-N.png"   height="500">

**3** Ne vom conecta toți în aceași rețea (e.g. pe acelasi WiFi) pentru
a trimite fișiere către alți colegi din sala. Nu vom mai rula peste Mininet.
Ne vom **grupa câte doi** pentru a trimite un fișier de la unul la celalalt. 
Mai exact, unul dintre voi va porni un server cu bind pe `INADDR_ANY`
(0.0.0.0), iar clientul va putea trimite catre ip-ul celuilalt fisierul. 

---
**Note**

Dacă folosiți mașini virtuale și nu aveți rețeaua pe modul Bridge, va
trebui să faceți port forwarding din setarile hypervisorului. Pentru
a verifica dacă sunteți în aceeasi retea, folositi `ip address
show` și confirmați că adresa este din același subnet cu cel al gazdei.

---
