# Exemplu client


Pentru a înțelege mai bine, vom studia următoarea implementare de
server și client ce folosește API-ul de sockeți:

  - **Client code, sends hello world message**


```c
#include <stdio.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>

int main(void)
{
    int socket_desc;
    struct sockaddr_in server_addr;
    char server_message[2000], client_message[2000];
    
    /* Clean buffers and structures*/
    memset(server_message,'\0',sizeof(server_message));
    memset(client_message,'\0',sizeof(client_message));
    memset(&server_addr, 0, sizeof(server_addr));
    
    /* Create socket, we use SOCK_STREAM for TCP */
    socket_desc = socket(AF_INET, SOCK_STREAM, 0);
    if(socket_desc < 0){
        printf("[CLIENT] Unable to create socket\n");
        return -1;
    }
    
    printf("[CLIENT] Socket created successfully\n");
    
    /* Set port and IP the same as server-side */
    server_addr.sin_family = AF_INET;
    server_addr.sin_port = htons(2000);
    server_addr.sin_addr.s_addr = inet_addr("127.0.0.1");
    
    /* Send connection request to server */
    if(connect(socket_desc, (struct sockaddr*)&server_addr, sizeof(server_addr)) < 0){
        printf("[CLIENT] Unable to connect\n");
        return -1;
    }
    printf("[CLIENT] Connected with server successfully\n");
    
    /* Get input from the user */
    printf("[CLIENT] Enter message: ");
    gets(client_message);
    
    /* Send the message to server */
    if(send(socket_desc, client_message, strlen(client_message), 0) < 0){
        printf("[CLIENT] Unable to send message\n");
        return -1;
    }
    
    /* Receive the response from server */
    if(recv(socket_desc, server_message, sizeof(server_message), 0) < 0){
        printf("[CLIENT] Error while receiving server's msg\n");
        return -1;
    }
    
    printf("[CLIENT] Server's response: %s\n",server_message);
    
    /* Close the socket */:
    close(socket_desc);
    
    return 0;
}
```
